function POLYFIT()

num_horz = 3;
num_vert = 2;

sigma = 2.3;

num_points = num_horz*num_vert + 100;

for i = 1:num_horz*num_vert
   subplot(num_vert, num_horz, i);

   % generate random polynom coefficients
   a = randpoly(i);

   x = rand(num_points, 1)*i;

   b = polyval(a, x);
   b = b + (randn(num_points, 1)*sigma);
   %b = b + abs(b).*(randn(num_points, 1)*sigma);

   plot(x, b, 'b+');
   hold on;

   A = zeros(num_points, i+1);
   for j=0:i
      A(:, j+1) = x.^j;
   end

   [est_a, res] = ausgleichsproblem(A, b);

   est_a = fliplr(est_a');

%  (a-est_a)./abs(a)

   dist = abs(max(x)-min(x));
   dist = 0;

   inter = (min(x)-dist/10):0.01:(max(x)+dist/10);
   pol   = polyval(est_a, inter);

   plot(inter, pol, 'r-', 'LineWidth', 2);
   title(['Polynomgrad = ',int2str(i)])
   hold off;

end

function a = randpoly(degree)

a = zeros(1, degree+1);

xv = 0:degree;
yv = randn(degree+1, 1)*10;

A = zeros(degree+1, degree+1);
for i=0:degree
   A(:, i+1) = xv.^i;
end

a = A\yv;
a = fliplr(a');
